Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscMat.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscMat.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscMat.h	(revision 12878)
@@ -0,0 +1,56 @@
+/*!\file:  PetscMat.h
+ * \brief wrapper to our own PetscMat object, which is needed to add AD capabilities (using ADOLC) 
+ * to a C-coded Petsc API. We are just wrapping the Petsc objects into C++ equivalent, so that 
+ * later, we can map all of the Petsc routines into Adolc equivalents.
+ */ 
+
+#ifndef _PETSCMAT_H_
+#define _PETSCMAT_H_
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "../petscincludes.h"
+#include "../../../include/include.h"
+
+/*}}}*/
+class PetscVec;
+
+class PetscMat{
+
+	public:
+		Mat matrix;
+
+		#ifdef _HAVE_ADOLC_
+		IssmDouble* amatrix;
+		#endif
+
+		/*PetscMat constructors, destructors {{{*/
+		PetscMat();
+		PetscMat(int M,int N);
+		PetscMat(int M,int N,IssmDouble sparsity);
+		PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity);
+		PetscMat(int M,int N,int connectivity,int numberofdofspernode);
+		~PetscMat();
+		/*}}}*/
+		/*PetscMat specific routines {{{*/
+		void Echo(void);
+		void Assemble(void);
+		IssmDouble Norm(NormMode norm_type);
+		void GetSize(int* pM,int* pN);
+		void GetLocalSize(int* pM,int* pN);
+		void MatMult(PetscVec* X,PetscVec* AX);
+		PetscMat* Duplicate(void);
+		IssmDouble* ToSerial(void);
+		void SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode);
+		void Convert(MatrixType type);
+		/*}}}*/
+
+};
+		
+#endif //#ifndef _PETSCMAT_H_
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscVec.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 12878)
@@ -0,0 +1,216 @@
+/*!\file PetscVec.cpp
+ * \brief: implementation of the PetscVec object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../petscincludes.h"
+#include "../../../shared/shared.h"
+
+/*}}}*/
+
+/*PetscVec constructors and destructor*/
+/*FUNCTION PetscVec::PetscVec(){{{*/
+PetscVec::PetscVec(){
+	this->vector=NULL;
+	#ifdef _HAVE_ADOLC_
+	this->avector=NULL;
+	#endif
+}
+/*}}}*/
+/*FUNCTION PetscVec::PetscVec(int M,bool fromlocalsize){{{*/
+PetscVec::PetscVec(int M,bool fromlocalsize){
+	
+	this->vector=NewVec(M,fromlocalsize);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::PetscVec(Vec petsc_vec){{{*/
+PetscVec::PetscVec(Vec petsc_vec){
+
+	if(petsc_vec==NULL){
+		this->vector=NewVec(0);
+	}
+	else{
+		/*copy vector*/
+		VecDuplicate(petsc_vec,&this->vector);
+		VecCopy(petsc_vec,this->vector);
+	}
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::PetscVec(IssmDouble* serial_vec,int M){{{*/
+PetscVec::PetscVec(IssmDouble* serial_vec,int M){
+
+	int* idxm=NULL;
+	if(M)idxm=xNew<int>(M);
+	for(int i=0;i<M;i++) idxm[i]=i;
+
+	this->vector=NewVec(M);
+	VecSetValues(this->vector,M,idxm,serial_vec,INSERT_VALUES);
+	VecAssemblyBegin(this->vector);
+	VecAssemblyEnd(this->vector);
+
+	xDelete<int>(idxm);
+}
+/*}}}*/
+/*FUNCTION PetscVec::~PetscVec(){{{*/
+PetscVec::~PetscVec(){
+    VecFree(&this->vector);
+}
+/*}}}*/
+
+/*PetscVec specific routines: */
+/*FUNCTION PetscVec::Echo{{{*/
+void PetscVec::Echo(void){
+
+	_assert_(this->vector);
+	VecView(this->vector,PETSC_VIEWER_STDOUT_WORLD);
+}
+/*}}}*/
+/*FUNCTION PetscVec::Assemble{{{*/
+void PetscVec::Assemble(void){
+		
+	_assert_(this->vector);
+	VecAssemblyBegin(this->vector); 
+	VecAssemblyEnd(this->vector);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::SetValues{{{*/
+void PetscVec::SetValues(int ssize, int* list, IssmDouble* values, InsMode mode){
+	
+	_assert_(this->vector);
+	VecSetValues(this->vector,ssize,list,values,ISSMToPetscInsertMode(mode));
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::SetValue{{{*/
+void PetscVec::SetValue(int dof, IssmDouble value, InsMode mode){
+
+	_assert_(this->vector);
+	VecSetValues(this->vector,1,&dof,&value,ISSMToPetscInsertMode(mode));
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::GetValue{{{*/
+void PetscVec::GetValue(IssmDouble* pvalue,int dof){
+
+	_assert_(this->vector);
+	VecGetValues(this->vector,1,&dof,pvalue);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::GetSize{{{*/
+void PetscVec::GetSize(int* pM){
+
+	_assert_(this->vector);
+	VecGetSize(this->vector,pM);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::GetLocalSize{{{*/
+void PetscVec::GetLocalSize(int* pM){
+
+	_assert_(this->vector);
+	VecGetLocalSize(this->vector,pM);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::Duplicate{{{*/
+PetscVec* PetscVec::Duplicate(void){
+	
+	PetscVec* output=NULL;
+	_assert_(this->vector);
+	Vec vec_output=NULL;
+	VecDuplicate(this->vector,&vec_output);
+	output=new PetscVec(vec_output);
+	VecFree(&vec_output);
+
+	return output;
+}
+/*}}}*/
+/*FUNCTION PetscVec::Set{{{*/
+void PetscVec::Set(IssmDouble value){
+
+	_assert_(this->vector);
+	VecSet(this->vector,value);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::AXPY{{{*/
+void PetscVec::AXPY(PetscVec* X, IssmDouble a){
+
+	_assert_(this->vector);
+	VecAXPY(this->vector,a,X->vector);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::AYPX{{{*/
+void PetscVec::AYPX(PetscVec* X, IssmDouble a){
+
+	_assert_(this->vector);
+	VecAYPX(this->vector,a,X->vector);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::ToMPISerial{{{*/
+IssmDouble* PetscVec::ToMPISerial(void){
+	
+	IssmDouble* vec_serial=NULL;
+	VecToMPISerial(&vec_serial, this->vector);
+	return vec_serial;
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::Copy{{{*/
+void PetscVec::Copy(PetscVec* to){
+
+	if(this->vector) VecCopy(this->vector,to->vector);
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::Norm{{{*/
+IssmDouble PetscVec::Norm(NormMode mode){
+
+	IssmDouble norm=0;
+	_assert_(this->vector);
+	VecNorm(this->vector,ISSMToPetscNormMode(mode),&norm);
+	return norm;
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::Scale{{{*/
+void PetscVec::Scale(IssmDouble scale_factor){
+
+	_assert_(this->vector);
+	VecScale(this->vector,scale_factor); 
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::Dot{{{*/
+IssmDouble PetscVec::Dot(PetscVec* input){
+
+	IssmDouble dot;
+	_assert_(this->vector);
+	VecDot(this->vector,input->vector,&dot);
+	return dot;
+
+}
+/*}}}*/
+/*FUNCTION PetscVec::PointwiseDivide{{{*/
+void PetscVec::PointwiseDivide(PetscVec* x,PetscVec* y){
+
+	_assert_(this->vector);
+	VecPointwiseDivide(this->vector,x->vector,y->vector);
+
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscVec.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscVec.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscVec.h	(revision 12878)
@@ -0,0 +1,62 @@
+/*!\file:  PetscVec.h
+ * \brief wrapper to our own PetscVec object, which is needed to add AD capabilities (using ADOLC) 
+ * to a C-coded Petsc API. We are just wrapping the Petsc objects into C++ equivalent, so that 
+ * later, we can map all of the Petsc routines into Adolc equivalents.
+ */ 
+
+#ifndef _PETSCVEC_H_
+#define _PETSCVEC_H_
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "../petscincludes.h"
+#include "../../../include/include.h"
+
+
+/*}}}*/
+
+class PetscVec{
+
+	public:
+		Vec vector;
+
+		#ifdef _HAVE_ADOLC_
+		IssmDouble* avector;
+		#endif
+
+
+		/*PetscVec constructors, destructors {{{*/
+		PetscVec();
+		PetscVec(int M,bool fromlocalsize=false);
+		PetscVec(IssmDouble* buffer, int M);
+		PetscVec(Vec petsc_vec);
+		~PetscVec();
+		/*}}}*/
+		/*PetscVec specific routines {{{*/
+		void Echo(void);
+		void Assemble(void);
+		void SetValues(int ssize, int* list, IssmDouble* values, InsMode mode);
+		void SetValue(int dof, IssmDouble value, InsMode  mode);
+		void GetValue(IssmDouble* pvalue, int dof);
+		void GetSize(int* pM);
+		void GetLocalSize(int* pM);
+		PetscVec* Duplicate(void);
+		void Set(IssmDouble value);
+		void AXPY(PetscVec* X, IssmDouble a);
+		void AYPX(PetscVec* X, IssmDouble a);
+		IssmDouble* ToMPISerial(void);
+		void Copy(PetscVec* to);
+		IssmDouble Norm(NormMode norm_type);
+		void Scale(IssmDouble scale_factor);
+		void PointwiseDivide(PetscVec* x,PetscVec* y);
+		IssmDouble Dot(PetscVec* vector);
+		/*}}}*/
+};
+
+#endif //#ifndef _PETSCVEC_H_
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/petscobjects.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/petscobjects.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/petscobjects.h	(revision 12878)
@@ -0,0 +1,11 @@
+/* \file petscobjects.h
+ * \brief all includes for our own petsc object implementation
+ */
+
+#ifndef _PETSC_OBJECTS_H_
+#define _PETSC_OBJECTS_H_
+
+#include "./PetscMat.h"
+#include "./PetscVec.h"
+
+#endif
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp	(revision 12878)
@@ -28,5 +28,5 @@
 
 	/*Gather all range values into allranges, for all nodes*/
-	allranges=(int*)xmalloc(num_procs*sizeof(int));
+	allranges=xNew<int>(num_procs);
 	MPI_Allgather(&range,1,MPI_INT,allranges,1,MPI_INT,MPI_COMM_WORLD);
 
@@ -42,7 +42,4 @@
 	*plower_row=lower_row;
 	*pupper_row=upper_row;
-
-	/*Free ressources:*/
-	xfree((void**)&allranges);
-
+	xDelete<int>(allranges);
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscInsertMode.cpp	(revision 12878)
@@ -30,5 +30,5 @@
 			break;
 		default: 
-			_error_("unknown insert mode!");
+			_error2_("unknown insert mode!");
 			break;
 	}
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscMatrixType.cpp	(revision 12878)
@@ -30,5 +30,5 @@
 			break;
 		default: 
-			_error_("unknown matrix type !");
+			_error2_("unknown matrix type !");
 			break;
 	}
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/ISSMToPetscNormMode.cpp	(revision 12878)
@@ -30,5 +30,5 @@
 			break;
 		default: 
-			_error_("unknown norm !");
+			_error2_("unknown norm !");
 			break;
 	}
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatInvert.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatInvert.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatInvert.cpp	(revision 12878)
@@ -29,5 +29,5 @@
 	/*Some checks: */
 	MatGetSize(matrix,&M,&N);
-	if(M!=N) _error_("trying to invert a non square matrix!");
+	if(M!=N) _error2_("trying to invert a non square matrix!");
 
 	/*Create identitiy matrix: */
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatMultPatch.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatMultPatch.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatMultPatch.cpp	(revision 12878)
@@ -64,5 +64,5 @@
 	}
 	else{
-		result=1;\
+		result=1;
 	}
 	return result;
@@ -89,6 +89,6 @@
 	range=upper_row-lower_row+1;
 	if (range){
-		index=(int*)xmalloc(range*sizeof(int));
-		values=(double*)xmalloc(range*sizeof(double));
+		index=xNew<int>(range);
+		values=xNew<double>(range);
 		for (int i=0;i<range;i++){
 			*(index+i)=lower_row+i;
@@ -103,6 +103,6 @@
 
 	/*Free ressources:*/
-	xfree((void**)&index);
-	xfree((void**)&values);	
+	xDelete<int>(index);
+	xDelete<double>(values);	
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatPartition.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatPartition.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatPartition.cpp	(revision 12878)
@@ -48,5 +48,5 @@
 			d_nz=0;
 			o_nz=0;
-			#ifdef _HAVE_PETSCDEV_
+			#if _PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 2
 			MatCreateAIJ(MPI_COMM_WORLD,PETSC_DETERMINE,PETSC_DETERMINE, 0,0,d_nz,PETSC_NULL,o_nz,PETSC_NULL,&outmatrix);
 			#else
@@ -55,5 +55,5 @@
 		}
 		else if (strcmp(type,"mpidense")==0){
-			#ifdef _HAVE_PETSCDEV_
+			#if _PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 2
 			MatCreateDense(MPI_COMM_WORLD,PETSC_DETERMINE,PETSC_DETERMINE, 0,0,PETSC_NULL,&outmatrix);
 			#else
@@ -62,5 +62,5 @@
 		}
 		else{
-			_error_("MatType %s not supported yet",type);
+			_error2_("MatType " << type << " not supported yet");
 		}
 		/*Assemble*/
@@ -77,5 +77,5 @@
 		count=0;
 		if (range){
-			node_rows=(int*)xmalloc(range*sizeof(int)); //this is the maximum number of rows one node can extract.
+			node_rows=xNew<int>(range); //this is the maximum number of rows one node can extract.
 		
 			for (i=0;i<row_partition_vector_size;i++){
@@ -98,5 +98,5 @@
 		
 		/*Same deal for columns*/
-		node_cols=(int*)xmalloc(col_partition_vector_size*sizeof(int));
+		node_cols=xNew<int>(col_partition_vector_size);
 		for (i=0;i<col_partition_vector_size;i++){
 			*(node_cols+i)=(int)*(col_partition_vector+i)-1;
@@ -128,6 +128,6 @@
 
 	/*Free ressources:*/
-	xfree((void**)&node_rows);
-	xfree((void**)&node_cols);
+	xDelete<int>(node_rows);
+	xDelete<int>(node_cols);
 	ISFree(&col_index);
 	ISFree(&row_index);
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatToSerial.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatToSerial.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/MatToSerial.cpp	(revision 12878)
@@ -32,5 +32,4 @@
 	double* outmatrix=NULL;
 	
-	
 	/*get matrix size: */
 	MatGetSize(matrix,&M,&N);
@@ -42,10 +41,10 @@
 	
 	/*Local and global allocation*/
-	if (my_rank==0)outmatrix=(double*)xmalloc(M*N*sizeof(double));
+	if (my_rank==0)outmatrix=xNew<double>(M*N);
 	
 	if (range){
-		local_matrix=(double*)xmalloc(N*range*sizeof(double));
-		idxm=(int*)xmalloc(range*sizeof(int));  
-		idxn=(int*)xmalloc(N*sizeof(int));  
+		local_matrix=xNew<double>(N*range);
+		idxm=xNew<int>(range);  
+		idxn=xNew<int>(N);  
 	 
 		for (i=0;i<N;i++){
@@ -78,13 +77,10 @@
 		//Still have the local_matrix on node 0 to take care of.
 		memcpy(outmatrix,local_matrix,N*range*sizeof(double));
-
 	} 
 	
 	/*Assign output pointer: */
 	*poutmatrix=outmatrix;
-	
-	xfree((void**)&idxm);
-	xfree((void**)&idxn);
-	xfree((void**)&local_matrix);
-
+	xDelete<int>(idxm);
+	xDelete<int>(idxn);
+	xDelete<double>(local_matrix);
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/NewMat.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 12878)
@@ -20,5 +20,5 @@
 #include "../../mpi/patches/mpipatches.h"
 
-/*NewMat(int M,int N){{{1*/
+/*NewMat(int M,int N){{{*/
 Mat NewMat(int M,int N){
 
@@ -39,5 +39,5 @@
 	o_nz=(int)((double)nnz/(double)M/2.0); //number of non zeros per row/2
 
-	#ifdef _HAVE_PETSCDEV_
+	#if _PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 2
 	MatCreateAIJ(MPI_COMM_WORLD,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
 	#else
@@ -48,5 +48,5 @@
 }
 /*}}}*/
-/*NewMat(int M,int N,double sparsity){{{1*/
+/*NewMat(int M,int N,double sparsity){{{*/
 Mat NewMat(int M,int N,double sparsity){
 
@@ -67,5 +67,5 @@
 	o_nz=(int)((double)nnz/(double)M/2.0); //number of non zeros per row/2
 
-	#ifdef _HAVE_PETSCDEV_
+	#if _PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 2
 	if(sparsity==1){
 		MatCreateDense(MPI_COMM_WORLD,m,n,M,N,NULL,&outmatrix); 
@@ -81,5 +81,5 @@
 }
 /*}}}*/
-/*NewMat(int M,int N,int connectivity,int numberofdofspernode){{{1*/
+/*NewMat(int M,int N,int connectivity,int numberofdofspernode){{{*/
 Mat NewMat(int M,int N,int connectivity,int numberofdofspernode){
 
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscMatrixToDoubleMatrix.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscMatrixToDoubleMatrix.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscMatrixToDoubleMatrix.cpp	(revision 12878)
@@ -36,12 +36,15 @@
 	MatGetSize(petsc_matrix,&rows,&cols);
 
-	idxm=(int*)xmalloc(rows*sizeof(int));
-	idxn=(int*)xmalloc(cols*sizeof(int));
+	idxm=xNew<int>(rows);
+	idxn=xNew<int>(cols);
 
 	for(i=0;i<rows;i++)idxm[i]=i;
 	for(i=0;i<cols;i++)idxn[i]=i;
 
-	matrix=(double*)xmalloc(rows*cols*sizeof(double));
+	matrix=xNew<double>(rows*cols);
 	MatGetValues(petsc_matrix,rows,idxm,cols,idxn,matrix);
+
+	xDelete<int>(idxm);
+	xDelete<int>(idxn);
 
 	/*Assign output pointers: */
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp	(revision 12878)
@@ -55,5 +55,5 @@
 			if(first[0]!='-'){
 				/*This is not good, the option does not have '-'! Get out*/
-				_error_("%s%s%s","Option ",first," should be preceded by '-'!");
+				_error2_("Option " << first << " should be preceded by '-'!");
 			}
 			/*Reduce first to bare option value*/
@@ -90,5 +90,5 @@
 	}
 
-#ifdef _HAVE_PETSCDEV_
+#if _PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 2
 	PetscTokenDestroy(&token);
 #else
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscVectorToDoubleVector.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscVectorToDoubleVector.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/PetscVectorToDoubleVector.cpp	(revision 12878)
@@ -28,9 +28,9 @@
 		VecGetSize(petsc_vector,&rows);
 		if(rows){
-			idxm=(int*)xmalloc(rows*sizeof(int));
-			vector=(double*)xmalloc(rows*sizeof(double));
+			idxm=xNew<int>(rows);
+			vector=xNew<double>(rows);
 			for(i=0;i<rows;i++)idxm[i]=i;
-
 			VecGetValues(petsc_vector,rows,idxm,vector);
+			xDelete<int>(idxm);
 		}
 	}
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/SerialToVec.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/SerialToVec.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/SerialToVec.cpp	(revision 12878)
@@ -38,6 +38,6 @@
 
 	if (range){
-		idxn=(int*)xmalloc(range*sizeof(int)); 
-		values=(double*)xmalloc(range*sizeof(double));
+		idxn=xNew<int>(range); 
+		values=xNew<double>(range);
 		for (i=0;i<range;i++){
 			idxn[i]=lower_row+i;
@@ -54,6 +54,6 @@
 
 	/*Free ressources:*/
-	xfree((void**)&idxn);
-	xfree((void**)&values);
+	xDelete<int>(idxn);
+	xDelete<double>(values);
 
 	return outvector;
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecMerge.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecMerge.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecMerge.cpp	(revision 12878)
@@ -35,5 +35,5 @@
 	/*If the dimension of the partitioning vector is not the same as that of vector B, we have a problem: */
 	if ( (row_partition_size !=MB) ){
-		_error_("Dimensions of partitioning vector incompatible with dimensions of input vector\n");
+		_error2_("Dimensions of partitioning vector incompatible with dimensions of input vector\n");
 	}
 
@@ -45,6 +45,6 @@
 	if (range){
 		/*This node owns rows of vector B, get them*/
-		idxm=(int*)xmalloc(range*sizeof(int));
-		values=(double*)xmalloc(range*sizeof(double));
+		idxm=xNew<int>(range);
+		values=xNew<double>(range);
 		for (i=0;i<range;i++){
 			*(idxm+i)=lower_row+i;
@@ -63,6 +63,5 @@
 
 	/*Free ressources:*/
-	xfree((void**)&idxm);
-	xfree((void**)&values);
-
+	xDelete<int>(idxm);
+	xDelete<double>(values);
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecPartition.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecPartition.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecPartition.cpp	(revision 12878)
@@ -56,5 +56,5 @@
 
 		if (range){
-			node_rows=(int*)xmalloc(range*sizeof(int)); //this is the maximum number of rows one node can extract.
+			node_rows=xNew<int>(range); //this is the maximum number of rows one node can extract.
 		
 			count=0;
@@ -71,8 +71,8 @@
 					
      	if (count){
-			values=(double*)xmalloc(count*sizeof(double)); //holder for the values to be extracted from vectorA
+			values=xNew<double>(count); //holder for the values to be extracted from vectorA
 		}
 		else{
-			xfree((void**)&node_rows); //count=0 means no values was condensed out for this node. null node_rows for use in VecGetValues.
+			xDelete<int>(node_rows); //count=0 means no values was condensed out for this node. null node_rows for use in VecGetValues.
 			values=NULL;
 		}
@@ -110,13 +110,9 @@
 		VecAssemblyBegin(outvector);
 		VecAssemblyEnd(outvector);
-		
 	}
 	
 	/*Assign output pointers:*/
 	*poutvector=outvector;
-
-	/*Free ressources:*/
-	xfree((void**)&node_rows);
-	xfree((void**)&values);
-
+	xDelete<int>(node_rows);
+	xDelete<double>(values);
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecToMPISerial.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecToMPISerial.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecToMPISerial.cpp	(revision 12878)
@@ -42,5 +42,5 @@
 
 	/*Allocate gathered vector on all nodes .*/
-	gathered_vector=(double*)xmalloc(vector_size*sizeof(double));
+	gathered_vector=xNew<double>(vector_size);
 	
 	/*Allocate local vectors*/
@@ -50,9 +50,9 @@
 
 	if (range){
-		idxn=(int*)xmalloc(range*sizeof(int)); 
+		idxn=xNew<int>(range); 
 		for (i=0;i<range;i++){
 			*(idxn+i)=lower_row+i;
 		} 
-		local_vector=(double*)xmalloc(range*sizeof(double));
+		local_vector=xNew<double>(range);
 		/*Extract values from MPI vector to serial local_vector on each node*/
 		VecGetValues(vector,range,idxn,local_vector); 
@@ -87,6 +87,6 @@
 	
 	/*free ressources: */
-	xfree((void**)&idxn);
-	xfree((void**)&local_vector);
+	xDelete<int>(idxn);
+	xDelete<double>(local_vector);
 	
 	return 1;
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecTranspose.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecTranspose.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/patches/VecTranspose.cpp	(revision 12878)
@@ -33,11 +33,11 @@
 
 	if (range){
-		idxm=(int*)xmalloc(range*sizeof(int)); 
-		tidxm=(int*)xmalloc(range*sizeof(int)); 
+		idxm=xNew<int>(range); 
+		tidxm=xNew<int>(range); 
 		for (i=0;i<range;i++){
 			*(idxm+i)=lower_row+i;
 		} 
-		values=(double*)xmalloc(range*sizeof(double));
-		tvalues=(double*)xmalloc(range*sizeof(double));
+		values=xNew<double>(range);
+		tvalues=xNew<double>(range);
 		
 		VecGetValues(vector,range,idxm,values);
@@ -56,8 +56,8 @@
 
 	/*Free ressources: */
-	xfree((void**)&idxm);
-	xfree((void**)&values);
-	xfree((void**)&tidxm);
-	xfree((void**)&tvalues);
+	xDelete<int>(idxm);
+	xDelete<double>(values);
+	xDelete<int>(tidxm);
+	xDelete<double>(tvalues);
 
 	/*Assign output pointers: */
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/petscincludes.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/petscincludes.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/petscincludes.h	(revision 12878)
@@ -16,4 +16,5 @@
 /*our own patches: */
 #include "patches/petscpatches.h"
+#include "objects/petscobjects.h"
 
 #endif
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/CyclicalFactorization.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/CyclicalFactorization.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/CyclicalFactorization.cpp	(revision 12878)
@@ -44,5 +44,5 @@
 	int i;
 
-	decomp=xmalloc(input*sizeof(int));
+	decomp=xNew<int>(input);
 	*decomp=input;
 	for (i=0;i<input;i++){
@@ -57,5 +57,4 @@
 		}
 	}
-
 	*pdecomp=decomp;
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/PlapackInvertMatrix.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/PlapackInvertMatrix.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/PlapackInvertMatrix.cpp	(revision 12878)
@@ -13,13 +13,11 @@
 #include "../../scalapack/FortranMapping.h"
 
-void PlapackInvertMatrixLocalCleanup(PLA_Obj* pa,PLA_Template* ptempl,double** parrayA,
-		int** pidxnA,MPI_Comm* pcomm_2d);
+void PlapackInvertMatrixLocalCleanup(PLA_Obj* pa,PLA_Template* ptempl,double** parrayA,int** pidxnA,MPI_Comm* pcomm_2d);
 	
 int PlapackInvertMatrix(Mat* A,Mat* inv_A,int status,int con){ 
-	/*inv_A does not yet exist, inv_A was just xmalloced, that's all*/
+	/*inv_A does not yet exist, inv_A was just allocated, that's all*/
 
 	/*Error management*/
 	int i,j;
-	
 
 	/*input*/
@@ -53,5 +51,5 @@
 
 	/*Some dimensions checks: */
-	if (mA!=nA) _error_(" trying to take the invert of a non-square matrix!");
+	if (mA!=nA) _error2_("trying to take the invert of a non-square matrix!");
 
 	/* Set default Plapack parameters */
@@ -94,5 +92,4 @@
 	/* Set the datatype */
 	datatype = MPI_DOUBLE;
-
 	
 	/* Copy A into a*/
@@ -104,6 +101,6 @@
 	upper_row--; 
 	range=upper_row-lower_row+1;
-	arrayA=xmalloc(nA*sizeof(double));
-	idxnA=xmalloc(nA*sizeof(int));
+	arrayA = xNew<double>(nA);
+	idxnA  = xNew<int>(nA);
 	for (i=0;i<nA;i++){
 		*(idxnA+i)=i;
@@ -128,10 +125,9 @@
 	PLA_Obj_free(&a);
 	PLA_Temp_free(&templ);
-	xfree((void**)&arrayA);
-	xfree((void**)&idxnA);
+	xDelete<double>(arrayA);
+	xDelete<int>(idxnA);
 	
 	/*Finalize PLAPACK*/
 	PLA_Finalize();
 	MPI_Comm_free(&comm_2d);
-
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/PlapackToPetsc.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/PlapackToPetsc.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/plapack/patches/PlapackToPetsc.cpp	(revision 12878)
@@ -45,6 +45,6 @@
 	
 	/*Vector physically based block cyclic distribution: */
-	row_nodes=xmalloc(mA*sizeof(int));
-	col_nodes=xmalloc(nA*sizeof(int));
+	row_nodes=xNew<int>(mA);
+	col_nodes=xNew<int>(nA);
 	for (i=0;i<mA;i++){
 		i0=i/nb;
@@ -60,5 +60,5 @@
 	PLA_Temp_comm_col_rank(templ,&myrow);
 
-	idxm=xmalloc(mA*sizeof(int));
+	idxm=xNew<int>(mA);
 	count=0;
 	for (i=0;i<mA;i++){
@@ -70,5 +70,5 @@
 	idxm_count=count;
 
-	idxn=xmalloc(nA*sizeof(int));
+	idxn=xNew<int>(nA);
 	count=0;
 	for (i=0;i<nA;i++){
@@ -92,7 +92,7 @@
 
 	/*Free ressources:*/
-	xfree((void**)&row_nodes);
-	xfree((void**)&col_nodes);
-	xfree((void**)&idxm);
-	xfree((void**)&idxn);
+	xDelete<int>(row_nodes);
+	xDelete<int>(col_nodes);
+	xDelete<int>(idxm);
+	xDelete<int>(idxn);
 }
